%  Approximate Cardinal Function Preconditioner
%
%  Input
%       A   N x N matrix
%   neigh   neighorhoods of each centers
%  
%  Output
%       W   preconditioned matrix

function W = acbfPreconditioner(A,neigh)

     N = length(A(1,:));
     W = zeros(N,N);
     
     for i=1:N
     
          [U,S,V] = svd(A(neigh(i,:),:)',0);                      
  W(i,neigh(i,:)) = ( V*( S\(U(i,:)')) )';    
     
     end
     
 
 
 

