function A = advectionDiffusionMqTrapezoid()
                                  
      dt = 0.002;  finalTime = 0.5;
       a = 1;                             % advection coefficient
      nu = 0.002;                         % diffusion coefficient
   shape = 7;    N = 51;
                                          
      x = linspace(0,1,N)'; o = ones(1,length(x));
     rx = x*o - (x*o)';     r = abs(rx);  
       
      U = exactSolution(x,0);                                              
      H = nu.*mqDerivatives(r,rx,shape,2) - a.*mqDerivatives(r,rx,shape,1);                        
      B = mq(r,shape);                                                           

      TL = B - 0.5*dt*H;
      TR = B + 0.5*dt*H;
       T = TL\TR;
       A = B*(T/B);

      A(1,:) = 0;  A(end,:) = 0;  
      A(1,1) = 1;  A(N,N) = 1;
      
    t=0;
    while t < finalTime
            u = A*U;
         u(N) = exactSolution(1,t);
            t = t + dt;
            U = u; 
    end  
   
    exact = exactSolution(x,finalTime);
    subplot(1,2,1), plot(x,exact,'r--',x,u,'b')
    subplot(1,2,2), plot(x,abs(U-exact))
           
   function ex = exactSolution(x,t)
          if t<dt 
            if length(x)>1
              ex(1)=1; ex(2:length(x))=0; ex = ex(:);
            else, ex = 0; end
          else
             ce = 2.0*sqrt(nu*t); w1 = (x-a*t)/ce; w2 = (x+a*t)/ce;
             ex = 0.5*(erfc(w1) + exp(a*x/nu).*erfc(w2));
          end
   end
end



  
  
