function advectionMQ1d()

        N = 40;
    shape = 4;
       dt = 0.001;  
finalTime = 1;
                                                   
  x = linspace(-1,1,N)'; 
  o = ones(1,length(x));
 rx = x*o - (x*o)';  r = abs(rx); 
    
 H = mqDerivatives(r,rx,shape,1);   % evaluation matrix H
 B = mq(r,shape);                   % system matrix B
dm = H/B;         % discretization D, of linear operator L
 K = cond(B); disp('K(B): '), disp(K)  
    
 dm(end,:)=0;  % zero Dirichlet BC at x=1

 U = exactSolution(x,0);   exact = exactSolution(x,0);
 hh = plot(x,U,x,exact,'erasemode','xor');
 set(hh(1),'Color',[0 0 1]);    % numerical in blue
 set(hh(2),'Color',[1 0 0]);    % exact in red
 axis([-1 1 -0.05 1.05]), pause
 
 t = 0;
 while t < finalTime 

    u = rk4(U,t,dt,@F);                  
    t = t + dt;
    U = u;
   
   exact = exactSolution(x,t);
   set(hh(1),'ydata',u,'Color',[0 0 1]), set(hh(2),'ydata',...
       exact,'Color',[1 0 0],'LineStyle','--'), drawnow
        
   end  
   eInf = norm(U-exact,inf)
   
   function fp = F(u,t)
         fp =  dm*u;
   end
         
   function ex = exactSolution(x,t)
       ex = exp( -40*( (x-0.4 + t).^2) );
   end
   
end



  
  
