

function advectionVariableShape()

% 
%  Ut - Ux = 0   on [-1,1]
%    U(x,0) = exp(-((x-0.4).^2)/(4*d^2)); 
%    U(1,t) = 0

        N = 40; 
       
% ----------- constant shape --------------------------- 
        
%        shape = 4; 
        
% ---------- variable shape ----------------------------                   
%        
         cMin = 1.8; cMax = 2.5; 
         cMin = cMin^2;                              
        cMax = cMax^2; 
           c = cMin*(cMax/cMin).^((0:N-1)./(N-1));                   % 1 x N
           c = sqrt(c);
       shape = repmat(c,N,1); 
%       
% ------------------------------------------------------        
                                            
        x = linspace(-1,1,N)'; 
        o = ones(1,length(x));
        rx = x*o - (x*o)';  r = abs(rx); 
    
       H = mqDerivatives(r,rx,shape,1);               % Evaluation Matrix H
       B = mq(r,shape);                               % System Matrix B
      dm = H/B;                                       % discretization D, of linear operator L
       K = cond(B); disp('K(B): '), disp(K)  
    
      dm(end,:)=0;  

    dt = 0.001;  
    finalTime = 1;
  
   U = exactSolution(x,0);   exact = exactSolution(x,0);

   
      hh = plot(x,U,x,exact,'erasemode','xor');
      set(hh(1),'Color',[0 0 1]);    % numerical in blue
      set(hh(2),'Color',[1 0 0]);    % exact in red

      axis([-1 1 -0.05 1.05])
      xlabel('x')
      ylabel('u(x,t)')
      pause
 
   
   t = 0;
   while t < finalTime 

         u = rk4(U,t,dt,@F);                   % 4th-order Runge-Kutta
         t = t + dt;
         U = u;
   
         exact = exactSolution(x,t);
         set(hh(1),'ydata',u,'Color',[0 0 1]), set(hh(2),'ydata',exact,'Color',[1 0 0],'LineStyle','--'), drawnow
        
        end  % while
   
%   exact = exactSolution(x,finalTime);
%   set(hh(1),'ydata',u,'Color',[0 0 1]), set(hh(2),'ydata',exact,'Color',[1 0 0],'LineStyle','--'), drawnow
   
   format long, format compact
   e2 = norm(U-exact,2)./sqrt(N)
   eInf = norm(U-exact,inf)
   format
   

      
      
      
   
% ----------- nested functions ---------------------------------

   function fp = F(u,t)
         fp =  dm*u;
   end
         
   function ex = exactSolution(x,t)
       ex = exp( -40*( (x-0.4 + t).^2) );
%       ex = exp( -( (x-0.4 + t).^2)/(4*d^2) );
   end
   

  
% ----------------------------------------------------------

   
end



  
  
