
function lambda = affinceSpaceSvdSolver(H,Nb,Np,f,thres)

     phiB = H(1:Nb,:);             
     phiL = H(Nb+1:Np,:);

    [U,S,V] = svd(phiB);   
      sigma = diag(S); 

    if nargin<5, thres = max(size(phiB))*eps(max(sigma)); end
    
     r = sum( sigma > thres );         %  estimate of numerical rank
    Si = diag( (sigma > thres)./sigma );
      
    phiBdag = V(:,1:Nb)*Si*U';         %   phiBdag = pinv(phiB);
    
      [U,S,V] = svd(phiB);
      psiB = V(:,Nb+1:end);            %      psiB = null(phiB);  
      
    F = f(Nb+1:Np);
    G = f(1:Nb);
    
    [U,S,V] = svd(phiL*psiB);
      sigma = diag(S); 

    if nargin<5, thres = max(size(phiL*psiB))*eps(max(sigma)); end
    
     r = sum( sigma > thres );         
    Si = diag( (sigma > thres)./sigma );
    
   % gamma = (phiL*psiB)\(F-phiL*phiBdag*G);    % or using GE
     gamma = V*Si*U'*(F - phiL*phiBdag*G);   
    lambda = phiBdag*G + psiB*gamma;
