
% dtvFilterMQ

close all, home, clear

      shape = 4.5;
      M = 200;
      N = 70;
      
      x = linspace(-1,1,M)';
 fExact = sin(x).*(x<0) + cos(x).*(x>=0);

     xc = linspace(-1,1,N)';
      f = sin(xc).*(xc<0) + cos(xc).*(xc>=0);
   
      rs = zeros(N,N);
    for i=1:N
      for j=1:N
        rs(i,j) = abs(xc(i) - xc(j));
      end
    end
    
    re = zeros(N,N);
    for i=1:M
      for j=1:N
        re(i,j) = abs(x(i) - xc(j));
      end
    end
    

      B = mq(rs,shape);         %  system matrix
      kappa = cond(B)
      
      H = mq(re,shape);         %  evaluation matrix

          lambda = B\f;
    
         fApprox = H*lambda;
    
     maxError = norm(fApprox - fExact,inf)
     
     L = 3;
     timeSteps = 500;
     v = dtvFilter(fApprox',L,timeSteps);
     
     plot(x,fApprox,'b',x,fExact,'r')
      xlabel 'x', ylabel 'f(x)'
     axis([-1 1 -1 1.2])
     figure
     plot(x,fExact,'r',x,v,'g')
      xlabel 'x', ylabel 'f(x)'
     axis([-1 1 -1 1.1])
     figure
     semilogy(x,abs(fApprox-fExact),'b',x,abs(v'-fExact),'g')
     axis([-1 1 10e-8 1])
     xlabel 'x', ylabel '|error|'

    
    
 
 

