%  EVALUATIONMATRIX2D - for MQ interpolation in 2d
%
% Output
%    H   the M x N MQ RBF evaluation matrix
% Input
%    xc  N  distinct centers
%     x  M  points at which to evaluate the RBF interpolant

function H = evaluationMatrixMQ2d(xc,x,shape)

     [m,n] = size(xc);  if n>m, xc = xc'; end  
     [m,n] = size(x);   if n>m,  x = x';  end 
     
      xx = x(:,1);   xy = x(:,2);
     xcx = xc(:,1); xcy = xc(:,2); 

      N = length(xcx);  M = length(xx);
   
     r = sqrt( (xx*ones(1,N) - ones(M,1)*xcx').^2 + ...
               (xy*ones(1,N) - ones(M,1)*xcy').^2 );    

     H = mq(r,shape);      %  M x N
