%
% frankeProblemGeneralizedMq.m
%  
  clear, home, close all

   xc = dlmread('frankeProblemCenters.txt',' ');               % load centers
     x = dlmread('frankeProblemEvaluationPoints.txt',' ');      % load evaluation points
     
     N = length(xc(:,1));
     M = length(x(:,1));
     
         f = frankesFunction(xc(:,1),xc(:,2));
    fExact = frankesFunction(x(:,1),x(:,2));
    
    r = zeros(N,N);
    for i=1:N
      for j=1:N
        r(i,j) = sqrt( ( xc(i,1) - xc(j,1)  )^2 + ( xc(i,2) - xc(j,2) )^2  );
      end
    end
    
    rh = zeros(M,N);
    for i=1:M
      for j=1:N
        rh(i,j) = sqrt( ( x(i,1) - xc(j,1)  )^2 + ( x(i,2) - xc(j,2) )^2  );
      end
    end
   
  index = 1;
  for shape=8.4:-0.25:0.4;
  
          sh(index) = shape;
           B = mq(r,shape);         %  system matrix

         warning off
        lambda = B\f;
         warning on
   
          H = mq(rh,shape);
    fApprox = H*lambda;
    
    maxError(index) = norm(fApprox - fExact,inf);
    
    
% --------------- generalized MQ --------------------------    
         e = 0.97;
        Bg = mqGeneralized(r,shape,e);         %  system matrix

         warning off
        lambdag = Bg\f;
         warning on

   
          Hg = mqGeneralized(rh,shape,e);
    fApproxg = Hg*lambdag;
    
    maxErrorg(index) = norm(fApproxg - fExact,inf);
     
    
% ---------------------------------------------------------    
   
              index = index + 1;    
  
 end

     semilogy(sh,maxError,'b',sh,maxErrorg,'r')
     xlabel 'shape \epsilon', ylabel 'error'
     


