%
% frankeProblemLocalGlobalKappa.m
%  
  clear, home, close all

   xc = dlmread('frankeProblemCenters.txt',' ');               % load centers
     x = dlmread('frankeProblemEvaluationPoints.txt',' ');      % load evaluation points
     
     N = length(xc(:,1))
     M = length(x(:,1))
     
         f = frankesFunction(xc(:,1),xc(:,2));
    fExact = frankesFunction(x(:,1),x(:,2));
    
    r = zeros(N,N);
    for i=1:N
      for j=1:N
        r(i,j) = sqrt( ( xc(i,1) - xc(j,1)  )^2 + ( xc(i,2) - xc(j,2) )^2  );
      end
    end
    
    rh = zeros(M,N);
    for i=1:M
      for j=1:N
        rh(i,j) = sqrt( ( x(i,1) - xc(j,1)  )^2 + ( x(i,2) - xc(j,2) )^2  );
      end
    end
   
  index = 1;
  for shape=8:-0.2:0.4;
  
          sh(index) = shape;
           B = mq(r,shape);         %  system matrix

         warning off
        lambda = B\f;
         warning on
        
     
      [U,S,V] = svd(B);
            S = diag(S);
            
    
        kappa(index) = max(S)/min(S);
        
                      beta = U'*f;
         localKappa(index) = sqrt(  sum( (beta./S).^2 ) );
        
   
          H = mq(rh,shape);
    fApprox = H*lambda;
    
    maxError(index) = norm(fApprox - fExact,inf);
   
              index = index + 1;    
  
 end
 
     semilogy(sh,kappa,'b--',sh,localKappa,'r')
     legend('\kappa','\kappa_{loc}')
     xlabel 'shape \epsilon', ylabel 'condition number'
     
     figure
     semilogy(sh,maxError,'b')
     xlabel 'shape \epsilon', ylabel 'error'
     


