% Takes matB (MC x nc*MC) matrix, with nc different
% values of c to find a column set, colset, of length MC. This method
% depend on the rhs column vector.  Solve  matB*ans = rhs

function [colset,ans] = greedyAlgorithm(matB,rhs)

 [MC,NC] = size(matB); 
    mrhs = length(rhs); 
       m = MC-1; 
       n = NC-1;
     mat = zeros(MC,NC);  
    rhsB = zeros(MC,1); 
    rhsB = rhs;  
     mat = matB; 

 [mv imv] = max(abs(rhs ));           % get maximum residual
 [nv inv] = max(abs(mat(imv,:)));     % maximum in corresponding rowmat

    coef = zeros(NC,1);  
    ainv = pinv(mat(imv,inv) );        % psuedo inverse
 
 coef(inv,1) = rhs(imv,1)*ainv;
 mcoef = length(coef); 
  mimv = length(imv);
  ninv = length(inv);

    colset = [inv];     % this will be the selected column set
    rowset = [imv];     % this will be the selected row set
         v = zeros(MC,1); 
  v(imv,1) = -coef(inv,1)*ainv;

 for k=2:MC;           %  loop for the new primal-dual algorithm
    r = mat*coef-rhs;   
    q = (coef+mat'*v); 
    [mv imv] = max(abs(r));  
    [nv inv] = max(abs(q));
    rowset = [rowset imv];   
    colset = [colset inv]; 
                                                       
     localMatrix = mat(rowset,colset);          % set up local system  
    [mM,nM] = size(localMatrix); 
    kappaLocalMatrix = cond(localMatrix);
    
   if kappaLocalMatrix > 1e18, break;  end

      rhsloc = rhs(rowset);
     inv_mat = pinv(localMatrix);                 % solve local system
    
                  Mrhs = length(rhsloc);
         [minmL,ninML] = size(localMatrix); 
     [minvmtK,ninvmtK] = size(localMatrix);
     
                  xloc = inv_mat*rhsloc;  
                  vloc = -(inv_mat')*xloc;   
        coef(colset,1) = xloc;     
           v(rowset,1) = vloc;
 end
 
 ans = coef(colset);
