
% greedyInterpolation

   clear, home, close all

   N = 40; M = 98;
  xc = linspace(-1,1,N)';
   x = linspace(-1,1,M)';
   
         f = exp(sin(pi*xc));
    fExact = exp(sin(pi*x));
    
    rs = zeros(N,N);
    for i=1:N
      for j=1:N
        rs(i,j) = abs(xc(i) - xc(j));
      end
    end
    
    re = zeros(N,N);
    for i=1:M
      for j=1:N
        re(i,j) = abs(x(i) - xc(j));
      end
    end
   
    
  shape = 1.1:-0.05:0.05;
  BT = [];
  HT = [];
  CT = [];
   X = xc;
   F = f;
  
  for i = 1:length(shape);
  
      c = shape(i);
  
     B = mq(rs,c);         %  system matrix
     H = mq(re,c);         %  evaluation matrix
     
     BT = [BT B];
     HT = [HT H];
     CT = [CT c*ones(N,1)];
      X = [X xc];
      F = [F f];
      
  end
  
  
      [colset,lambda] = greedyAlgorithm(BT,f);
  
     lambda = BT(:,colset)\f;               % LSQ via QR
     fApprox = HT(:,colset)*lambda;
  
     size(colset)
     maxError = norm(fApprox - fExact,inf)

     
         xColset = X(colset);
     shapeColset = CT(colset);
         fColset = F(colset);
     
     figure
     plot(x,fExact,'b',xc,f,'k.',xColset,fColset,'ro')
     xlabel 'x', ylabel 'f(x)'
     
     figure
     plot(xColset,shapeColset,'b*')
     axis([-1.1 1.1 0 1.15])
     xlabel 'center location', ylabel 'shape parameter'
 
  
