function ug = grpRbf(S,L,m,ak,xr,xc,shape)    
  % gegenbauerPolynomial.m and im.m are part of the MPT
  %   http://www.scottsarra.org/mpt/mpt.html 

     M = length(xr);          %  evaluate the GRP approx at M points
    sN = length(S);           %  number of discontinuities and endpoints
   siN = sN - 1;              %  number of sub-intervals
 
    Nq = 300;                 % number of quadrature points
    j = 0:Nq;                 %  Chebyshev-Gauss-Lobatto quadrature points
   xj = -cos(j*pi/Nq)';                   
 
      gh = zeros(siN,max(m)+1);  %  Gegenbauer coefficients
      ug = zeros(1,M);   %  reconstructed function at the reconstruction pts

 % ------- find GRP coefficients ----------------------------------  
 
     wt = pi.*ones(1,Nq+1)./Nq;   % Chebyshev-Gauss-Lobbato quadrature weights
     wt(1) = 0.5*wt(1); 
     wt(end) = 0.5*wt(end); 

for i = 1:siN                                           % u_N( x[xi] )
   sL = S(i); sR = S(i+1); mi = m(i); Li = L(i); 
    % RBF approx evaluated at mapped quadrature nodes
    H = evaluationMatrixMQ(xc,im(sL,sR,xj,0),shape);   
   uC = H*ak;
        
 for el=0:mi
  hi = (gamma(Li)*(el+Li))/(sqrt(pi)*gegenbauerPolynomial(el,Li,1.0)*gamma(Li+0.5));
  fq = uC.*((1.0-xj.^2).^Li).*gegenbauerPolynomial(el,Li,xj);                            
  gh(i,el+1) = hi*sum(fq.*wt');
 end % el
end   % i
       
 % ------- reconstruct function ------------------------------------     

for i=1:M
     for j=1:siN
      if xr(i)>=S(j) & xr(i)< S(j+1)
         sL = S(j); sR = S(j+1); mi = m(j); Li = L(j);
         for el = 0:mi
          ug(i) = ug(i) + gh(j,el+1)*gegenbauerPolynomial(el,Li,im(sL,sR,xr(i),1));  
         end
         break  % get out of the j loop, the interval has been found
     end  % if in interval
    end  % for j
end  % for i
          
          i=M;                               
          ug(M)=0;
          sL = S(siN); sR = S(siN+1); mi = m(siN); Li = L(siN);
          for el = 0:mi
            ug(i) = ug(i) + gh(j,el+1)*gegenbauerPolynomial(el,Li,im(sL,sR,xr(i),1));   
          end
          ug = ug(:);

