function  heatComplexDomain()

centers = dlmread('centers.txt',' ');
      x = centers(:,1);  y = centers(:,2);  N = length(x);
    bpi = dlmread('centersBoundaryIndex.txt',' ');
     NB = length(bpi); NI = N - NB;

  xb = x(bpi);  yb = y(bpi); % re-order centers to put boundary centers last
 ipi = NB+1:1:N; xi = x(ipi); yi = y(ipi);  x = [xi; xb];   y = [yi; yb];
 
   o = ones(1,length(x));
  rx = (x*o - (x*o)');
  ry = (y*o - (y*o)');
   r = sqrt( rx.^2 + ry.^2 );
   
shape = 2;  dt = 0.0005;
H = mqDerivatives(r,rx,shape,2) + mqDerivatives(r,ry,shape,2); % Evaluation matrix
B = mq(r,shape);                                               % System matrix
dm = H/B;                                 % discretization D, of linear operator L
   
       finalTime = 0.1;
       U = exactSolution(x,y,0);                     % initial condition
       td = delaunay(x,y);  hh = trisurf(td,x,y,U); 
       bpi = NI+1:N;                                % boundary points must be last

    pause, t = 0;
    while t < finalTime
       u = rk4(U,t,dt,@F);
       t = t + dt;
       u(bpi) = exactSolution(x(bpi),y(bpi),t);
       U = u;
       hh = trisurf(td,x,y,U);  drawnow;
   end  % while
   
xlabel 'x', ylabel 'y', pause
hh = trisurf(td,x,y,abs(U-exactSolution(x,y,finalTime)));
er = max( abs(U-exactSolution(x,y,finalTime)) ), xlabel 'x', ylabel 'y', drawnow

  function fp = F(u,t)
         u(bpi) = exp(-5*t*pi^2).*sin(x(bpi)*pi).*sin(2*pi*y(bpi));
         fp = dm*u;
  end

  function e =  exactSolution(x,y,t)
    e = exp(-5*t*pi^2).*sin(x*pi).*sin(2*pi*y);
  end

end

