 
% NOTE: heatComplexStabilityFdMode.m sets up the dm and determines dt (fix)
%       for eigenvalue stability

 function heatComplexDomainFdMode(dm,dt)  
 
% -------------- load centers ----------------------
     
    centers = dlmread('centers.txt',' ');
    x = centers(:,1);  y = centers(:,2);  N = length(x);
       
    bpi = dlmread('centersBoundaryIndex.txt',' ');            
    NB = length(bpi);
    NI = N - NB;
         
       finalTime = 0.1;
       U = exactSolution(x,y,0);                                      % initial conditions  
       td = delaunay(x,y); hh = trisurf(td,x,y,U);
                          
% ---------------------------------------------------      
          
  pause
   t = 0;
   while t < finalTime       
       u = rk4(U,t,dt,@F);                  
       t = t + dt;
       u(bpi) = exactSolution(x(bpi),y(bpi),t);
       U = u;
       hh = trisurf(td,x,y,U);  drawnow;
   end  % while
  
    pause

    hh = trisurf(td,x,y,abs(U-exactSolution(x,y,finalTime)));   % error
    er = max( abs(U-exactSolution(x,y,finalTime)) )
    xlabel 'x', ylabel 'y'
    title(sprintf('t = %d',finalTime)), drawnow


% ---------------  nested functions ----------------------------------------- 

  function fp = F(u,t) 
         u(bpi) = exp(-5*t*pi^2).*sin(x(bpi)*pi).*sin(2*pi*y(bpi));       
         fp = dm*u;      
   end

  function e =  exactSolution(x,y,t) 
      e = exp(-5*t*pi^2).*sin(x*pi).*sin(2*pi*y);
  end    
     
% -----------------------------------------------------------------------
  
end
