
function [x,aInv,r,thres] = improvedTruncatedSvd(A,b,thres)

     [V,S,U] = svd(A);
       sigma = diag(S);
 
     if nargin<3, thres = max(size(A))*eps(max(sigma)); end
%     if nargin<3, thres = max(sigma)*(10e-8); end

     r = sum( sigma > thres );        % estimate of numerical rank
     
      sigmaI = diag( 1./diag(S) );                %  inverse of full S

       I = diag(S) >= thres;
       m = min(find(I==0));           %  m is index of first sigma thresholdeded
      Si = diag( I./diag(S) );        %  inverse of thresholded S
      x1 = U*Si*(V'*b);                 %  truncated SVD solution
      
    if m>=1
          
          U1 = U(:,1:m);      % left singlular vectors of TSVD
          V1 = V(:,1:m);      % right singlular vectors of TSVD
          
          U2 = null(U1');     % orthogonal complement of U1
          V2 = null(V1');     % orthogonal complement of V1
          
               b2 = V2'*b;
                C = V2'*A*U2;
           kappaC = cond(C)   

          z2 = (U2')*(U*sigmaI*V')*(V2)*V2'*b;     %  or   z2 = C\b2;    
           x = x1 + U2*z2;
        aInv = U*Si*V'  +  U2*(U2')*(U*sigmaI*V')*(V2)*(V2');
      
    else

        x = x1;
     aInv = U*Si*V';
  
    end

    

  

   
