
% locallyAdaptiveMQ

  clear, home, close all

      c = 4.5;
      M = 200;
      N = 70;    
      
      c = c*ones(1,N);
      
      x = linspace(-1,1,M)';
 fExact = sin(x).*(x<0) + cos(x).*(x>=0);

     xc = linspace(-1,1,N)';
      f = sin(xc).*(xc<0) + cos(xc).*(xc>=0);
   
      rs = zeros(N,N);
    for i=1:N
      for j=1:N
        rs(i,j) = abs(xc(i) - xc(j));
      end
    end
    
    re = zeros(N,N);
    for i=1:M
      for j=1:N
        re(i,j) = abs(x(i) - xc(j));
      end
    end
    
      L = 33; R = 37;
      
      shape = repmat(c,N,1);    
      B = mq(rs,shape);         %  system matrix
      B(:,L:R) = rs(:,L:R);
      
      kappa = cond(B)
      
      shape = repmat(c,M,1);
      H = mq(re,shape);         %  evaluation matrix
      H(:,L:R) = re(:,L:R);  
      
      
     
          lambda = B\f;
         fApprox = H*lambda;
         
      c = 4.5; 
      B = mq(rs,c);         %  system matrix
      kappaMQ = cond(B)
      H = mq(re,c);         %  evaluation matrix
 
 
           lambdaMQ = B\f;
         fApproxMQ = H*lambdaMQ;
    

     
     plot(x,fExact,'r',x,fApprox,'b')
     axis([-1 1 -1 1.1])
     xlabel 'x', ylabel 'f(x)'

     figure
     semilogy(x,abs(fApproxMQ-fExact),'b',x,abs(fApprox-fExact),'g')
      xlabel 'x', ylabel '|error|'
     axis([-1 1 10e-12 1])

     figure
     semilogy(1:N,abs(lambdaMQ),'b')
     xlabel 'center number', ylabel '|\lambda|'

  
  
