%  MQ  Multiquadric Radial Basis Function

function m = mq(r,c,ch)
 
   if nargin<3, ch=2; end           
   
   if ch == -402 
      m = ( 3.*c.^4.*( 4.*c.^2.*r.^2 - 1 ) )./(1 + (r.*c).^2).^(3.5);
   elseif ch == -302 
      m = (-3.*c.^4.*r)./(1 + (r.*c).^2).^(2.5);
   elseif ch == -202 
      m = (c.*c)./(1 + (r.*c).^2).^(1.5);
   elseif ch == -102 
      m = (r.*c.*c)./sqrt(1 + (r.*c).^2);
   elseif ch == 2                      
      m = sqrt(1 + (r.*c).^2);
   elseif ch == 102                                            
      m = 0.5*r.*sqrt(1 + r.^2.*c.^2) +  0.5*asinh(c.*r)./c;
   elseif ch == 202                                            
      m = (1 + r.^2.*c.^2).^(0.3e1 ./ 0.2e1) ./ c.^2 ./ 0.6e1 + (c.*r.*asinh(c.*r) - sqrt(1 + r.^2*c.^2)) ./ c.^2 ./ 0.2e1; 
   elseif ch == 302
     m = (c.*r.*sqrt(1 + c.^2.*r.^2).*(-13 + 2.*c.^2.*r.^2) + 3.*(-1 + 4.*c.^2.*r.^2).*asinh(c.*r))./(48.*c.^3);
   elseif ch == 402
     m = ((sqrt(1 + c.^2.*r.^2).*(16 - 83.*c.^2.*r.^2 + 6.*c.^4.*r.^4) + 15.*c.*r.*(-3 + 4.*c.^2.*r.^2).*asinh(c.*r))./(720.*c.^4));    
   elseif ch==502
     m = (c.*r.*sqrt(1 + c.^2.*r.^2).*(113 - 194.*c.^2.*r.^2 + 8.*c.^4.*r.^4) + 15.*(1 - 12.*c.^2.*r.^2 + 8.*c.^4.*r.^4).*asinh(c.*r))./(5760.*c.^5); 
   elseif ch==602
     m = (sqrt(1 + c.^2.*r.^2).*(-128 + 1779.*c.^2.*r.^2 - 1518.*c.^4.*r.^4 + 40.*c.^6.*r.^6) + 105.*c.*r.*((5 - 20.*c.^2.*r.^2 + 8.*c.^4.*r.^4)).* ...
         asinh(c.*r))./(201600.*c.^6);
   elseif ch==702
    m = (c.*r.*sqrt(1 + c.^2.*r.^2).*(-1873 + 8654.*c.^2.*r.^2 - 4408.*c.^4.*r.^4 + 80.*c.^6.*r.^6) + 35.*(-5 + 120.*c.^2.*r.^2 - 240.*c.^4.* ... 
         r.^4 + 64.*c.^6.*r.^6).*asinh(c.*r))./(3225600.*c.^7);    
   elseif ch==802
    m = (sqrt(1 + c.^2.*r.^2).*(2048 - 54511.*c.^2.*r.^2 + 125634.*c.^4.*r.^4 - 42472.*c.^6.*r.^6 + 560.*c.^8.*r.^8) + 315.*c.*r.*(-35 + 280.*c.^2.* ... 
        r.^2 - 336.*c.^4.*r.^4 + 64.*c.^6.*r.^6).*asinh(c.*r))./(203212800.*c.^8);
   elseif ch==902  
    m =  (c.*r.*sqrt(1 + c.^2.*r.^2).*(30563 - 270778.*c.^2.*r.^2 + 373656.*c.^4.*r.^4 - 89872.*c.^6.*r.^6 + 896.*c.^8.*r.^8) + 315.*(7 - 280.*c.^2  ...
          .*r.^2 + 1120.*c.^4.*r.^4 - 896.*c^6.*r.^6 + 128.*c.^8.*r.^8).*asinh(c.*r))./(3251404800.*c.^9);
   elseif ch==1002
    m = (sqrt(1 + c.^2.*r.^2).* (-32768 + 1420105.*c.^2.*r.^2 - 6282750.*c.^4.*r.^4 + 5768872.*c.^6.*r.^6 - ...
            1036976.*c.^8.*r.^8 + 8064.*c.^10.*r.^10) +  3465.*c.*r.*(63 - 840.*c.^2.*r.^2 + 2016.*c.^4.*r.^4 - ...
             1152.*c.^6.*r.^6 + 128.*c.^8.*r.^8).*asinh(c.*r))./(321889075200.*c.^10);
  elseif ch==1102
   m =  (c.*r.*sqrt(1 + c.^2.*r.^2).*(-1237955 + 17867830.*c.^2.*r.^2 - 47374224.*c.^4.*r.^4 + ...
            31017232.*c.^6.*r.^6 - 4322624.*c.^8.*r.^8 +  26880.*c.^10.*r.^10) +  3465.*(-21 + 1260.*c.^2.*r.^2 - 8400.*c.^4.*r.^4 + ...
            13440.*c.^6.*r.^6 - 5760.*c.^8.*r.^8 + 512.*c.^10.*r.^10).*asinh(c.*r))./(12875563008000.*c.^11);
  end

