
% nonStationaryInterpolation

  clear, home, close all

  shape = 5;
      M = 298;
      x = linspace(-1,1,M)';
 fExact = exp(sin(pi*x));
 
 warning off
  
      n = 10:10:250;
  
  bnd = zeros(1,length(n));
  for k = 1:length(n);
  
      N = n(k);
  
     xc = linspace(-1,1,N)';
      h = abs(xc(2)-xc(1));
  alpha = 0.25;
     
      f = exp(sin(pi*xc));
   
      rs = zeros(N,N);
    for i=1:N
      for j=1:N
        rs(i,j) = abs(xc(i) - xc(j));
      end
    end
    
    re = zeros(N,N);
    for i=1:M
      for j=1:N
        re(i,j) = abs(x(i) - xc(j));
      end
    end
      
      B = mq(rs,shape);         %  system matrix
      H = mq(re,shape);         %  evaluation matrix
      
      
     
          lambda = B\f;
    
         fApprox = H*lambda;
    
     maxError(k) = norm(fApprox - fExact,inf);
     
     bnd(k) = alpha^(1/(shape*h));
    
     
  end
  
  semilogy(n,maxError,'b*-',n(1:14),bnd(1:14),'r--')
  xlabel 'N', ylabel '|error|', title '\epsilon = 5'
  axis([0 250 10e-10 1])
  
  warning on
  
  
  
