 
   Nb = 22;       %  boundary centers/exterior centers
    N = 60;       %  interior and boundary centers
   Np = 82;       %  total number of centers: interior, exterior, and boundary
                  %  the 22 boundary centers are in 1:22
   shape=0.6;
                  
   centers = dlmread('centersUnitCircle60BoundryCollocation.txt',' ');
   x = centers(:,1);  y = centers(:,2);

   u = 65./(65 + (x - 0.2).^2 + (y + 0.1).^ 2);              % exact solution
   f = 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*x-0.4).^2 ...
     - 260./(65 + (x-0.2).^2 + (y+0.1).^2).^2 + 130./(65 ...
     + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*y+0.2).^ 2;

    H = zeros(Np,Np);  rx = zeros(Np,Np);  ry = zeros(Np,Np);  r = zeros(Np,Np);
    
    f(1:Nb) = u(1:Nb);                           % Dirichlet Boundary conditions
 
    for i=1:N                                                                                
      for j=1:Np
         rx(i,j) = x(i) - x(j); 
         ry(i,j) = y(i) - y(j); 
         r(i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
    
    for i=1:Nb                                                                                 
      for j=1:Np
         rx(N+i,j) = x(i) - x(j); 
         ry(N+i,j) = y(i) - y(j); 
         r(N+i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
    
        H(1:Nb,:) = mq(r(1:Nb,:),shape);                                
        Hxx = mqDerivatives(r(Nb+1:Np,:),rx(Nb+1:Np,:),shape,2);
        Hyy = mqDerivatives(r(Nb+1:Np,:),ry(Nb+1:Np,:),shape,2);
        H(Nb+1:Np,:) = Hxx + Hyy;
        
          alpha = H\f;
              B = mq(r,shape);                                              
             uh = B*alpha;
         
         errror = norm(u(1:N)-uh(1:N),inf);
     


  
