%
% poissonExampleIMQ7.m
%  
%   MQ asymmetric collocation

   clear, home, close all
   
   Nb = 22;       %  number of boundary points
   Np = 60;       %  total number of center, interior and boundary
   
   fileName = 'c:\docs\Matlab\work\p2008m\mq_m\elliptic\centersUnitCircle60.txt';   
   centers = dlmread(fileName,' '); 
   x = centers(:,1);  y = centers(:,2);
   
   u = 65./(65 + (x - 0.2).^2 + (y + 0.1).^ 2);                % exact solution

   f = 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*x-0.4).^2 - 260./(65 + (x-0.2).^2 ...
     + (y+0.1).^2).^2 + 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*y+0.2).^ 2;

    H = zeros(Np,Np);   rx = zeros(Np,Np);   ry = zeros(Np,Np);   r = zeros(Np,Np);
    
    f(1:Nb) = u(1:Nb);                               % Dirichlet Boundary conditions
 
    for i=1:Np                                                                                 
      for j=1:Np
         rx(i,j) = x(i) - x(j); 
         ry(i,j) = y(i) - y(j); 
         r(i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
    
   
  index = 1;
  for shape=0.5*10e5+50.2:-5000:50.02;

        H(1:Nb,:) = mq(r(1:Nb,:),shape,702);                                %   system matrix
        Hxx = mqDerivatives(r(Nb+1:Np,:),rx(Nb+1:Np,:),shape,2,702);
        Hyy = mqDerivatives(r(Nb+1:Np,:),ry(Nb+1:Np,:),shape,2,702);
        H(Nb+1:Np,:) = Hxx + Hyy;
        
        kappa(index) = cond(H);
       
         warning off
         alpha = H\f;
         warning on
     
          B = mq(r,shape,702);                                              %   evaluation matrix
         uh = B*alpha;
         
         er(index) = norm(u-uh,inf);
         sh(index) = shape;
             index = index + 1;   

  end

   loglog(sh,er,'b')
   xlabel 'shape parameter', ylabel 'max error'
   
   figure
   loglog(sh,kappa)
   xlabel 'shape parameter', ylabel '\kappa(H)'


%  axis([100 10e5 10e-14 10e-2])
  
