%
% poissonExtendedPrecision.m 
%  

   clear, home, close all
   digits(50);
   tic
   
   Nb = 22;       %  number of boundary points
   Np = 60;       %  total number of center, interior and boundary
     
   centers = dlmread('centersUnitCircle60.txt',' ');  centers = centers;
   x = centers(:,1);  y = centers(:,2);

  u = 65./(65 + (x - 0.2).^2 + (y + 0.1).^ 2);                % exact solution

   f = 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*x-0.4).^2 - 260./(65 + (x-0.2).^2 ...
     + (y+0.1).^2).^2 + 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*y+0.2).^ 2;
   
   x = vpa(x);
   y = vpa(y);
   

    H = zeros(Np,Np);   rx = zeros(Np,Np);   ry = zeros(Np,Np);   r = zeros(Np,Np);
    
     H = vpa(H);
    rx = vpa(rx);
    ry = vpa(ry);
     r = vpa(r);
    
    f(1:Nb) = u(1:Nb);                               % Dirichlet Boundary conditions
 
    for i=1:Np                                                                                 
      for j=1:Np
         rx(i,j) = x(i) - x(j); 
         ry(i,j) = y(i) - y(j); 
         r(i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
    
   
  index = 1;
  for shape= 0.32:-0.05:0.07;


        H(1:Nb,:) = vpa( mq(r(1:Nb,:),shape) );                                %   system matrix
        Hxx = vpa( mqDerivatives(r(Nb+1:Np,:),rx(Nb+1:Np,:),shape,2) );
        Hyy = vpa( mqDerivatives(r(Nb+1:Np,:),ry(Nb+1:Np,:),shape,2) );
        H(Nb+1:Np,:) = Hxx + Hyy;
  
       
         warning off
         alpha = vpa( H\f );
         warning on
     
          B = vpa( mq(r,shape) );                                              %   evaluation matrix
         uh = vpa( B*alpha );
  er(index) = norm( double(vpa(u-uh)),inf);
        
         sh(index) = shape;
             index = index + 1;   

  end

   semilogy(sh,er,'b')
   xlabel 'shape parameter', ylabel 'max error'
   toc
   
%  axis([100 10e5 10e-14 10e-2])
  
