%
% poissonGreedySingleShape.m
%  
%   MQ asymmetric collocation

   clear, home, close all
   
   Nb = 22;       %  number of boundary points
   Np = 60;       %  total number of center, interior and boundary
     
   centers = dlmread('centersUnitCircle60.txt',' ');  centers = centers;
   x = centers(:,1);  y = centers(:,2);

   u = 65./(65 + (x - 0.2).^2 + (y + 0.1).^ 2);                % exact solution
   
   f = 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*x-0.4).^2 - 260./(65 + (x-0.2).^2 ...
     + (y+0.1).^2).^2 + 130./(65 + (x-0.2).^2 + (y+0.1).^2).^3.*(2.*y+0.2).^ 2;

    H = zeros(Np,Np);   rx = zeros(Np,Np);   ry = zeros(Np,Np);   r = zeros(Np,Np);
    
    f(1:Nb) = u(1:Nb);                               % Dirichlet Boundary conditions
 
    for i=1:Np                                                                                 
      for j=1:Np
         rx(i,j) = x(i) - x(j); 
         ry(i,j) = y(i) - y(j); 
         r(i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
    
       shape=0.11

        H(1:Nb,:) = mq(r(1:Nb,:),shape);               % evaluation matrix
        Hxx = mqDerivatives(r(Nb+1:Np,:),rx(Nb+1:Np,:),shape,2);
        Hyy = mqDerivatives(r(Nb+1:Np,:),ry(Nb+1:Np,:),shape,2);
        H(Nb+1:Np,:) = Hxx + Hyy;
        
        kappa = cond(H)
        B = mq(r,shape);       % system matrix
       
% ----------------------------------------------------------------

      [cols,ans]  = greedyAlgorithm(H,f);
      lambda = H(:,cols)\f;          % least square solution of over-determined system
     
      fApprox = H(:,cols)*lambda;
          uha = B(:,cols)*lambda;
          erp = norm(u-uha,inf)
        nRank = max( size(cols) )



% ------------------------------------------------------------------       
         
        
