%
% poissonLocalGlobalKappa.m
%  
%   MQ asymmetric collocation

   clear, home, close all

  
   Nb = 128;       %  number of boundary points
   Np = 492;       %  total number of center, interior and boundary
     
   centers = dlmread('intersectingCircleCenters.txt',' ');  centers = centers;
   x = centers(:,1);  y = centers(:,2);

    lambda = 1;
        mu = 2;
 
    u = exp( lambda*x + mu*y );                                     % exact solution
    f = ( lambda^2 + mu^2 ).*exp( lambda*x + mu*y );
    H = zeros(Np,Np);   rx = zeros(Np,Np);   ry = zeros(Np,Np);   r = zeros(Np,Np);
    
    f(1:Nb) = u(1:Nb);                               % Dirichlet Boundary conditions
 
    for i=1:Np                                                                                 
      for j=1:Np
         rx(i,j) = x(i) - x(j); 
         ry(i,j) = y(i) - y(j); 
         r(i,j) = sqrt( rx(i,j)^2 + ry(i,j)^2 );                    
      end
    end
   
  index = 1;
  for shape=8.0:-0.25:0.25;
  
          sh(index) = shape;

        H(1:Nb,:) = mq(r(1:Nb,:),shape);                                %   system matrix
        Hxx = mqDerivatives(r(Nb+1:Np,:),rx(Nb+1:Np,:),shape,2);
        Hyy = mqDerivatives(r(Nb+1:Np,:),ry(Nb+1:Np,:),shape,2);
        H(Nb+1:Np,:) = Hxx + Hyy;
        
         warning off
         alpha = H\f;
         warning on
         
         [U,S,V] = svd(H);
               S = diag(S);
            
    
        kappa(index) = max(S)/min(S);
        
                      beta = U'*f;
         localKappa(index) = sqrt(  sum( (beta./S).^2 ) );
         
               index = index + 1;    
  
 end
 
     semilogy(sh,kappa,'b--',sh,localKappa,'r')
     legend('\kappa','\kappa_{loc}')
     xlabel 'shape \epsilon', ylabel 'condition number'


