
% stationaryInterpolation

  clear, home, close all

   N = 100; M = 198;
  xc = linspace(-1,1,N)';
   x = linspace(-1,1,M)';
   
         f = exp(sin(pi*xc));
    fExact = exp(sin(pi*x));
    
    rs = zeros(N,N);
    for i=1:N
      for j=1:N
        rs(i,j) = abs(xc(i) - xc(j));
      end
    end
    
    re = zeros(N,N);
    for i=1:M
      for j=1:N
        re(i,j) = abs(x(i) - xc(j));
      end
    end
   
    
   alpha = 0.25;
        h = abs(xc(2)-xc(1));
  
  shape = 19.5:-1:0.5;
  bnd = zeros(1,length(shape));
  
  for i = 1:length(shape);
  
      c = shape(i);
  
     B = mq(rs,c);         %  system matrix
     H = mq(re,c);         %  evaluation matrix
     
      lambda = B\f;
     fApprox = H*lambda;
  
     maxError(i) = norm(fApprox - fExact,inf);
     
          
     bnd(i) = alpha^(1/(c*h));
     
  end
  
  
  

  semilogy(shape,maxError,'b*-',shape(1:17),bnd(1:17),'r--')
  xlabel '\epsilon', ylabel '|error|', title 'N = 100'
  axis([0 20 10e-9 1])
  
  
