%  SYSTEMMATRIX2D 
%
% Output
%    B   the N x N MQ RBF system matrix
% Input
%    xc  N distinct centers

function B = systemMatrixMQ2d(xc,shape)

    [M,N] = size(xc);
    if N>M, xc = xc'; end  
   
     x = xc(:,1);    y = xc(:,2);
     o = ones(1,length(x));
     
     r = sqrt(  (x*o - (x*o)').^2 + (y*o - (y*o)').^2 ); 
     B = mq(r,shape);      %  N x N
