
function vBurgersMQ()

    nu = 5*0.000875; dt = 0.001;  finalTime = 1.2;
     N = 140;  shape = 11;
     x = linspace(-1,1,N)';
     o = ones(1,length(x));
     rx = x*o - (x*o)';  % signed distance matrix 
      r = abs(rx);       % distance matrix  

     Hx = mqDerivatives(r,rx,shape,1);
    Hxx = mqDerivatives(r,rx,shape,2);

        B = mq(r,shape);
       dm = Hx/B;
      dm2 = Hxx/B;

    U = exactSol(x,0);  t=0;
    while t < finalTime
         u = rk4(U,t,dt,@F);
         t = t + dt;
         u(1) = exactSol(-1,t); u(N) = exactSol(1,t);  U = u;
    end  % while

   exact = exactSol(x,finalTime);
   subplot(1,2,1), plot(x,exact,'r',x,u,'b')
   subplot(1,2,2), plot(x,abs(U-exact))

% ------------ nested functions ----------------------------------

 function ex = exactSol(x,t)
   x2 = x+1.0; aa = 0.05*(x2 - 0.5 + 4.95*t)/nu;
   bb = 0.25*(x2 - 0.5 + 0.75*t)/nu;  cc = 0.5*(x2-0.375)/nu;
   ex = (0.1*exp(-aa)+0.5*exp(-bb)+exp(-cc))./(exp(-aa)+exp(-bb)+exp(-cc));
 end

  function fp = F(u,t)
       u(1) = exactSol(-1,t); u(end) = exactSol(1,t);
         fp =  -0.5*dm*u.^2 + nu*dm2*u;
  end
% --------------------------------------
end
